// Copyright (c) 2024-2026 Celestino Amoroso (celestino.amoroso@gmail.com).
// All rights reserved.

// operator-length.go
package expr

import (
	"git.portale-stac.it/go-pkg/expr/kern"
	"git.portale-stac.it/go-pkg/expr/scan"
	"git.portale-stac.it/go-pkg/expr/sym"
	"git.portale-stac.it/go-pkg/expr/types/array"
	"git.portale-stac.it/go-pkg/expr/types/dict"
	"git.portale-stac.it/go-pkg/expr/types/list"
	"git.portale-stac.it/go-pkg/expr/types/str"
)

//-------- length term

func newLengthTerm(tk *scan.Token) (inst *scan.Term) {
	return &scan.Term{
		Tk:       *tk,
		Children: make([]*scan.Term, 0, 1),
		Position: scan.PosPrefix,
		Priority: scan.PriSign,
		EvalFunc: evalLength,
	}
}

func evalLength(ctx kern.ExprContext, opTerm *scan.Term) (v any, err error) {
	var childValue any

	if childValue, err = opTerm.EvalPrefix(ctx); err != nil {
		return
	}

	if array.IsArray(childValue) {
		ls, _ := childValue.(*array.ArrayType)
		v = int64(len(*ls))
	} else if str.IsString(childValue) {
		s, _ := childValue.(string)
		v = int64(len(s))
	} else if dict.IsDict(childValue) {
		m, _ := childValue.(*dict.DictType)
		v = int64(len(*m))
	} else if lls, ok := childValue.(*list.LinkedList); ok {
		v = int64(lls.Len())
	} else if it, ok := childValue.(kern.Iterator); ok {
		v = int64(it.Count())
	} else {
		err = opTerm.ErrIncompatiblePrefixPostfixType(childValue)
	}
	return
}

// init
func init() {
	scan.RegisterTermConstructor(sym.SymHash, newLengthTerm)
}
